import { Injector } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
import { NativeFirebaseApp } from './native-firebase';
export interface FirebaseAppConfig {
    /**
     * Name of the app internally used by firebase. If non is given one will be generated.
     */
    name?: string;
    /**
     * Firebase App configuration.
     */
    options: {
        apiKey: string;
        authDomain?: string;
        databaseURL?: string;
        storageBucket?: string;
        messagingSenderId?: string;
    };
}
export declare class FirebaseApp {
    config: FirebaseAppConfig;
    private injector;
    nativeApp: NativeFirebaseApp;
    private _auth;
    private _database;
    constructor(config: FirebaseAppConfig, injector: Injector);
    delete(): Observable<void>;
    /**
     * Get the with this {@link FirebaseApp} associated {@link FirebaseAuth} instance.
     */
    auth(): FirebaseAuth;
    /**
     * Get the with this {@link FirebaseApp} associated {@link FirebaseDatabase}.
     *
     * The type parameter T is used to supply the schema of your database. If you do not want to
     * use one set it to `any`. Using a schema provides type safety when accessing the database.
     */
    database<T>(): FirebaseDatabase<T>;
}
