var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injector, NgModule } from '@angular/core';
import { FirebaseApp } from './firebase-app.service';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
/** @internal */
var lazyInvocation = true;
/** @internal */
export function invokeLazy() {
    return lazyInvocation;
}
/**
 * Enable or disable lazy invocation of firebase operations.
 *
 * Since the library focuses on observables, all operations are invoked lazily as is usually the
 * case with observables. This means for example, calling `someRef.set({ foo: 'bar' })` will do
 * nothing without either subscribing to the returned observable or calling `toPromise()` on it.
 *
 * This is in contrast to the Firebase Web-API which starts the operation when the function is
 * called. It is possible to globally configure the library to behave like the native Firebase
 * Web-API by calling `setLazyInvocation(false)`
 *
 * @param lazy
 */
export function setLazyInvocation(lazy) {
    lazyInvocation = lazy;
}
/** @internal */
export function appFactory(injector, config) {
    return new FirebaseApp(config, injector);
}
/** @internal */
export function authFactory(app) {
    return app.auth();
}
/** @internal */
export function databaseFactory(app) {
    return app.database();
}
var FirebaseModule = FirebaseModule_1 = (function () {
    function FirebaseModule() {
    }
    /**
     * Provides a firebase app which will be be injected for {@link FirebaseApp}. Further the app's
     * {@link FirebaseAuth} and {@link FirebaseDatabase} can be injected in the same way.
     * @param config Firebase app config.
     */
    FirebaseModule.primaryApp = function (config) {
        return {
            ngModule: FirebaseModule_1,
            providers: [
                {
                    provide: 'firebase-config-' + config.options.apiKey,
                    useValue: config
                },
                {
                    provide: FirebaseApp,
                    useFactory: appFactory,
                    deps: [Injector, 'firebase-config-' + config.options.apiKey]
                },
                {
                    provide: FirebaseAuth,
                    useFactory: authFactory,
                    deps: [FirebaseApp]
                },
                {
                    provide: FirebaseDatabase,
                    useFactory: databaseFactory,
                    deps: [FirebaseApp]
                }
            ]
        };
    };
    /**
     * Provides a {@link FirebaseApp} which will be injected for token.
     *
     * @param token Token for which {@link FirebaseApp} will be injected.
     * @param config Firebase app config.
     */
    FirebaseModule.secondaryApp = function (token, config) {
        return {
            ngModule: FirebaseModule_1,
            providers: [
                {
                    provide: 'firebase-config-' + config.options.apiKey,
                    useValue: config
                },
                {
                    provide: token,
                    useFactory: appFactory,
                    deps: [Injector, 'firebase-config-' + config.options.apiKey,]
                }
            ]
        };
    };
    return FirebaseModule;
}());
FirebaseModule = FirebaseModule_1 = __decorate([
    NgModule({})
], FirebaseModule);
export { FirebaseModule };
var FirebaseModule_1;
//# sourceMappingURL=firebase.module.js.map