import { Observable } from 'rxjs/Observable';
import { fromPromise } from 'rxjs/observable/fromPromise';
import { invokeLazy } from './firebase.module';
export function wrapExternalPromise(promise) {
    return new Promise(function (resolve, reject) {
        promise
            .then(function (res) { return resolve(res); })
            .catch(function (err) { return reject(err); });
    });
}
export function wrapPromise(promiseFact) {
    if (invokeLazy()) {
        return new Observable(function (sub) {
            fromPromise(wrapExternalPromise(promiseFact()))
                .subscribe(sub);
        });
    }
    return fromPromise(wrapExternalPromise(promiseFact()));
}
//# sourceMappingURL=utils.js.map